<template>
    <div class="app-container">
        <div class="filter-container">
            <el-row :gutter="20">
                <el-col :span="16" ref="filter" :model="filter">
                    <el-input prop="keyword" v-model="filter.keyword" ref="keyword" name="keyword" placeholder="Metode pembayaran" style="width: 300px;" size="medium" class="filter-item" clearable @keyup.enter.native="handleSearch" @clear="handleSearch"/>
                    <el-button @click="handleSearch" size="mini" type="primary" class="filter-item">
                        <i class="ion-ios-search"></i> Cari
                    </el-button>
                </el-col>
                <el-col :span="8" class="text-align-right">
                    <el-button v-permission="[null, 'paymentmethod', 'create']" @click="handleCreate" size="mini" type="success">
                        <i class="ion-ios-add-circle"></i> Tambah Metode Pembayaran
                    </el-button>
                </el-col>
            </el-row>            
        </div>
        <el-table v-loading="tableLoading" :data="paymentMethods" ref="paymentMethodTable" style="width: 100%" :height="tableHeight" fit highlight-current-row>
            <el-table-column
                fixed="left"
                label="Metode Pembayaran"
                width="200">
                <template slot-scope="scope">
                    <span style="color:#3E89FA;">{{ scope.row.name }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Deskripsi"
                width="250">
                <template slot-scope="scope">
                    <span>{{ scope.row.description }}</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Charge (IDR)"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.charge > 0" type="success" size="mini"> {{ scope.row.charge.format(2,0,',','.') }}</el-tag>
                    <el-tag v-else type="info" size="mini">{{ scope.row.charge.format(2,0,',','.') }}</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                label="Charge (%)"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.charge_percent > 0" type="success" size="mini"> {{ scope.row.charge_percent.format(2,0,',','.') }}</el-tag>
                    <el-tag v-else type="info" size="mini">{{ scope.row.charge_percent.format(2,0,',','.') }}</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                label="Fee (IDR)"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.fee > 0" type="success" size="mini"> {{ scope.row.fee.format(2,0,',','.') }}</el-tag>
                    <el-tag v-else type="info" size="mini">{{ scope.row.fee.format(2,0,',','.') }}</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                label="Fee (%)"
                width="150">
                <template slot-scope="scope">
                    <el-tag v-if="scope.row.fee_percent > 0" type="success" size="mini"> {{ scope.row.fee_percent.format(2,0,',','.') }}</el-tag>
                    <el-tag v-else type="info" size="mini">{{ scope.row.fee_percent.format(2,0,',','.') }}</el-tag>
                </template>
            </el-table-column>
            <el-table-column
                label="Pemilik"
                width="150"
                v-if="me.role.slug == 'root'">
                <template slot-scope="{row}">
                    <span v-if="row.owner">{{ row.owner.profile.fullname }}</span>
                    <span v-else>Default</span>
                </template>
            </el-table-column>
            <el-table-column
                label="Terakhir Diubah"
                width="150">
                <template slot-scope="scope">
                    {{ dateFormat(scope.row.updated) }}
                </template>
            </el-table-column>
            <el-table-column
                fixed="right"
                label="Tindakan"
                min-width="200">
                <template slot-scope="{row}">                    
                    <el-button v-permission="[row, 'paymentmethod', 'viewown']" type="text" @click="handleEdit(row)">Ubah</el-button>
                    <el-button v-permission="[row, 'paymentmethod', 'deleteown']" type="text" class="text-danger" @click="handleDelete(row)">Hapus</el-button>
                </template>
            </el-table-column>
        </el-table>
        
        <pagination v-show="pagination.pages>1" :total="pagination.total" :page.sync="pagination.page" :perpage.sync="pagination.perpage" @pagination="handleSearch" />

        <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
            <el-form ref="paymentMethodForm" :model="paymentMethodForm" :rules="paymentMethodRules">
                <aside>
                    <el-alert type="info" description="Mengatur metode pembayaran yang akan digunakan untuk setiap transaksi." :closable=false show-icon></el-alert>
                </aside>
                <el-form-item label="Nama Metode Pembayaran" prop="name">
                    <el-input ref="name" name="name" v-model="paymentMethodForm.name" placeholder="Nama metode pembayaran" autocomplete="off" maxlength="255" show-word-limit></el-input>
                </el-form-item>
                <el-row :gutter="20">
                    <el-col  :lg="12" :md="24" :xs="24">
                        <el-form-item label="Charge (IDR)" prop="charge">
                            <el-input type="number" ref="charge" name="charge" v-model="paymentMethodForm.charge" placeholder="Jumlah" autocomplete="off" min="0">
                                <template slot="prepend">IDR</template>
                            </el-input>
                        </el-form-item>
                    </el-col>
                    <el-col  :lg="12" :md="24" :xs="24">
                        <el-form-item label="Charge (%)" prop="charge_percent">
                            <el-input type="number" ref="charge_percent" name="charge_percent" v-model="paymentMethodForm.charge_percent" placeholder="Jumlah" autocomplete="off" min="0" max="100">
                                <template slot="append">%</template>
                            </el-input>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-row :gutter="20">
                    <el-col  :lg="12" :md="24" :xs="24">
                        <el-form-item label="Fee (IDR)" prop="fee">
                            <el-input type="number" ref="fee" name="fee" v-model="paymentMethodForm.fee" placeholder="Jumlah" autocomplete="off" min="0">
                                <template slot="prepend">IDR</template>
                            </el-input>
                        </el-form-item>
                    </el-col>
                    <el-col  :lg="12" :md="24" :xs="24">
                        <el-form-item label="Fee (%)" prop="fee_percent">
                            <el-input type="number" ref="fee_percent" name="fee_percent" v-model="paymentMethodForm.fee_percent" placeholder="Jumlah" autocomplete="off" min="0" max="100">
                                <template slot="append">%</template>
                            </el-input>
                        </el-form-item>
                    </el-col>
                </el-row>
                <el-form-item label="Deskripsi" prop="description">
                    <el-input type="textarea" ref="description" name="description" v-model="paymentMethodForm.description" placeholder="Deskripsi metode pembayaran" autocomplete="off" maxlength="255" :autosize="{ minRows: 2, maxRows: 4}" show-word-limit></el-input>
                </el-form-item>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="showDialog = false" size="medium">Batal</el-button>
                <el-button v-permission="[null, 'paymentmethod', 'editown']" @click="handleSubmit" size="mini" type="success">
                    <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                </el-button>
            </span>
        </el-dialog>

    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import Pagination from '@/components/Pagination';
import { parseError, playSound, dateFormat, tableHeight } from '@/utils/index';

export default {
    name: 'PaymentMethod',
    components: {
        Pagination
    },
    directives: {
        permission
    },
    data(){

        return {
            tableLoading: false,
            dialogLoading: false,
            filter: {
                keyword: ''
            },
            showDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Ubah Metode Pembayaran',
                create: 'Tambah Metode Pembayaran'
            },
            paymentMethodForm: {
                id: null,
                name: '',
                charge: 0,
                charge_percent: 0,
                fee: 0,
                fee_percent: 0,
                description: ''
            },
            paymentMethodRules: {
                name: [{ 
                    required: true, message: 'Nama metode pembayaran wajib diisi', trigger: 'blur'
                }, {
                    max: 255, message: 'Panjang nama metode pembayaran maksimal 255 karakter', trigger: 'blur',
                }, {
                    pattern: /^([a-zA-Z0-9-()&\s/+.,]{1,255})$/, message: 'Hanya huruf, angka, tanda minus, tanda kurung, ampersand, garis miring, tanda plus, titik, koma dan spasi yang diperbolehkan', trigger: 'blur'
                }],
                description: [{ 
                    max: 255, message:'Panjang deskripsi maksimal 255 karakter', trigger: 'blur'
                }],
                charge: [{
                    pattern: /^\d+$/, message: 'Hanya angka yang diperbolehkan', trigger: 'blur'
                }],
                charge_percent: [{
                    pattern: /^([0-9]|[1-8][0-9]|9[0-9]|100)$/, message: 'Hanya angka yang diperbolehkan', trigger: 'blur'
                }],
                fee: [{
                    pattern: /^\d+$/, message: 'Hanya angka yang diperbolehkan'
                }],
                fee_percent: [{
                    pattern: /^([0-9]|[1-8][0-9]|9[0-9]|100)$/, message: 'Hanya angka yang diperbolehkan'
                }]
            },
        };
    },
    computed: {
        tableHeight,
        ...mapGetters('user', ['me']),
        ...mapGetters('paymentMethod', [
            'paymentMethods',
            'pagination'
        ])
    },
    created() {
        this.getPaymentMethods();
    },
    methods: {
        playSound,
        dateFormat,
        getPaymentMethods() {
            this.tableLoading = true;
            this.$store.dispatch('paymentMethod/getPaymentMethods', {
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleSearch(){
            this.tableLoading = true;
            this.$store.dispatch('paymentMethod/getPaymentMethods', {
                q: this.filter.keyword,
                page: this.pagination.page,
                perpage: this.pagination.perpage
            }).then(() => {
                this.tableLoading = false;
            });
        },
        handleCreate(){
            this.dialogStatus = 'create';
            this.showDialog = true;          
            this.$nextTick(() => {
                this.$refs['paymentMethodForm'].clearValidate();
            });
        },
        handleEdit(paymentMethod){
            this.dialogStatus = 'edit';
            this.showDialog = true;   
            this.paymentMethodForm.id = paymentMethod.id;
            this.paymentMethodForm.name = paymentMethod.name;
            this.paymentMethodForm.charge = paymentMethod.charge;
            this.paymentMethodForm.charge_percent = paymentMethod.charge_percent;
            this.paymentMethodForm.fee = paymentMethod.fee;
            this.paymentMethodForm.fee_percent = paymentMethod.fee_percent;
            this.paymentMethodForm.description = paymentMethod.description;  
            this.$nextTick(() => {
                this.$refs['paymentMethodForm'].clearValidate()
            });     
        },
        handleSubmit(){
            this.$refs.paymentMethodForm.validate((valid) => {
                if(valid){

                    let action = '';
                    let payload = {};

                    this.dialogLoading = true;

                    if(this.dialogStatus == 'create'){
                        action = 'paymentMethod/addPaymentMethod';
                        payload = {
                            name: this.paymentMethodForm.name,
                            charge: this.paymentMethodForm.charge,
                            charge_percent: this.paymentMethodForm.charge_percent,
                            fee: this.paymentMethodForm.fee,
                            fee_percent: this.paymentMethodForm.fee_percent,
                            description: this.paymentMethodForm.description
                        };
                    }else if(this.dialogStatus == 'edit'){
                        action = 'paymentMethod/editPaymentMethod';
                        payload = {
                            id: this.paymentMethodForm.id,
                            name: this.paymentMethodForm.name,
                            charge: this.paymentMethodForm.charge,
                            charge_percent: this.paymentMethodForm.charge_percent,
                            fee: this.paymentMethodForm.fee,
                            fee_percent: this.paymentMethodForm.fee_percent,
                            description: this.paymentMethodForm.description
                        };
                    }

                    this.$store.dispatch(action, payload).then((response) => {
                        this.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            this.$message.error({
                                message: error.messages
                            });
                        }else{
                            this.showDialog = false;
                            this.$message.success({
                                message: response.message
                            });
                            this.resetForm();
                        }

                        this.playSound();

                    });

                }else{
                    return false;
                }
            });
        },
        handleDelete(paymentMethod){
            this.$confirm('Anda mencoba untuk menghapus data metode pembayaran, data tidak bisa dikembalikan setelah dihapus. Anda yakin?', 'Peringatan', {
                confirmButtonText: 'Ya, Hapus',
                cancelButtonText: 'Batal'
            }).then(() => {
                this.tableLoading = true;
                this.$store.dispatch('paymentMethod/deletePaymentMethod', {
                    id: paymentMethod.id
                }).then((response) => {
                    this.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        this.$message.error({
                            message: error.messages
                        });
                    }else{
                        this.showDialog = false;
                        this.$message.success({
                            message: response.message
                        });
                    }

                    this.playSound();
                });
            });
        },
        resetForm() {
            this.paymentMethodForm = {
                id: null,
                name: '',
                charge: 0,
                charge_percent: 0,
                fee: 0,
                fee_percent: 0,
                description: ''
            }
        }
    }

}
</script>
